"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var context_1 = __importDefault(require("../context"));
var isHandler = function (key) { return /^on[A-Z]+/.test(key); };
var EventWrapper = /** @class */ (function (_super) {
    __extends(EventWrapper, _super);
    function EventWrapper() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    EventWrapper.prototype.render = function () {
        var _a = this.props, children = _a.children, tag = _a.as, restProps = __rest(_a, ["children", "as"]);
        var props = restProps;
        var ctrl = this.context.ctrl;
        for (var key in props) {
            if (isHandler(key)) {
                var handler = ctrl[props[key]];
                if ('function' === typeof handler) {
                    props[key] = handler;
                }
            }
        }
        return react_1.default.createElement(tag ? tag : 'div', props, children);
    };
    EventWrapper.contextType = context_1.default;
    EventWrapper.defaultProps = {
        as: 'div',
    };
    return EventWrapper;
}(react_1.default.Component));
exports.default = EventWrapper;
