import React, { Component } from 'react';
declare global {
    interface Document {
        attachEvent: typeof document.addEventListener;
        detachEvent: typeof document.removeEventListener;
    }
}
export interface OuterClickWrapperProps {
    onClick?: Function;
    children?: React.ReactNode;
}
export default class OuterClickWrapper extends Component<OuterClickWrapperProps> {
    componentDidMount(): void;
    componentWillUnmount(): void;
    contains(rootNode: Element | Text | null, node: Node | null): boolean;
    handleOutterClick: (event: Event) => void;
    render(): React.ReactNode;
}
