"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UPDATE_INPUT_VALUE = exports.UPDATE_STATE_BY_PATH = exports.__PAGE_DID_BACK__ = exports.UPDATE_STATE = exports.INDENTITY = void 0;
/**
 * 共享的 action 函数
 */
var util_1 = require("../util");
var INDENTITY = function (state) { return state; };
exports.INDENTITY = INDENTITY;
var UPDATE_STATE = function (state, newState) {
    return __assign(__assign({}, state), newState);
};
exports.UPDATE_STATE = UPDATE_STATE;
var __PAGE_DID_BACK__ = function (state, location) {
    return __assign(__assign({}, state), { location: location });
};
exports.__PAGE_DID_BACK__ = __PAGE_DID_BACK__;
var UPDATE_STATE_BY_PATH = function (state, payload) {
    return Object.keys(payload).reduce(function (state, path) { return (0, util_1.setValueByPath)(state, path, payload[path]); }, state);
};
exports.UPDATE_STATE_BY_PATH = UPDATE_STATE_BY_PATH;
exports.UPDATE_INPUT_VALUE = exports.UPDATE_STATE_BY_PATH;
