/// <reference types="node" />
import { EntireConfig } from '..';
export declare const getAllFiles: (dir: string) => Promise<string[]>;
/**
 * get html/css/javascript in target dir
 */
export declare const getHtmlCssJsFiles: (dir: string) => Promise<string[]>;
export declare const revStaticAssets: (staticDir: string) => Promise<Record<string, string>>;
export declare const replaceManifestInDir: (replaceDir: string, manifest: Record<string, string>) => Promise<void>;
export declare function getAssets(stats: Record<string, any>): Record<string, string>;
export declare function readAssets(config: EntireConfig): Record<string, any>;
type Manifest = Record<string, string>;
export declare function replace(contents: string, manifest: Manifest): string;
export declare function revPath(path: string, hash: string): string;
export default function revisionHash(data: string | Buffer): string;
export declare function getHashFilename(originalPath: string, contents: Buffer | string): string;
export {};
