import webpack from 'webpack';
import webpackDevMiddleware from 'webpack-dev-middleware';
import type { NextHandleFunction } from 'connect';
import type { EntireConfig } from '..';
export declare function setupClient(config: EntireConfig): Promise<{
    compiler: webpack.Compiler;
    middleware: webpackDevMiddleware.WebpackDevMiddleware & NextHandleFunction;
}>;
interface SetupServerOptions {
    handleHotModule: (value: any) => void;
}
export declare function setupServer(config: EntireConfig, options: SetupServerOptions): Promise<unknown>;
export declare function reporter(middlewareOptions: webpackDevMiddleware.Options, options: webpackDevMiddleware.ReporterOptions): void;
export {};
