import React from 'react';
import type { BaseLocation } from 'create-history';
export type LinkProps = React.PropsWithChildren<{
    as?: keyof HTMLElementTagNameMap;
    to?: string | BaseLocation;
    href?: string;
    replace?: boolean;
    back?: boolean;
    forward?: boolean;
    go?: number;
    prefetch?: boolean;
    [propName: string]: any;
}>;
export default class Link extends React.Component<LinkProps> {
    static contextType: React.Context<{
        ctrl: import("../controller").default<any, any>;
        location: import("create-app/lib").HistoryLocation;
        history: import("create-history").HistoryWithBFOL<import("create-history").BLWithBQ, import("create-history").ILWithBQ>;
        state: any;
        actions: import("relite").Currings<any, any>;
        preload: import("..").Preload | undefined;
        matcher: import("create-app/lib").Matcher;
        loader: import("create-app/lib").Loader;
        prefetch: (url: string) => import("create-app/lib").ControllerConstructor<import("create-app/lib").Controller> | Promise<import("create-app/lib").ControllerConstructor<import("create-app/lib").Controller>> | null;
    }>;
    static defaultProps: LinkProps;
    componentDidMount(): void;
    render(): JSX.Element;
    handleClick: (event: React.MouseEvent<HTMLElement>) => void;
}
