"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var Link_1 = __importDefault(require("./Link"));
var connect_1 = __importDefault(require("../hoc/connect"));
var withLocation = (0, connect_1.default)(function (_a) {
    var state = _a.state;
    return {
        location: state.location,
    };
});
exports.default = withLocation(NavLink);
function NavLink(props) {
    var getIsActive = props.isActive, location = props.location, className = props.className, children = props.children, activeClassName = props.activeClassName, style = props.style, activeStyle = props.activeStyle, to = props.to, rest = __rest(props, ["isActive", "location", "className", "children", "activeClassName", "style", "activeStyle", "to"]);
    var isActive = checkActive(to, location, getIsActive);
    var finalClassName = (0, classnames_1.default)(className, isActive && activeClassName);
    var finalStyle = isActive ? __assign(__assign({}, style), activeStyle) : style;
    return (react_1.default.createElement(Link_1.default, __assign({ to: to, className: finalClassName, style: finalStyle }, rest), children));
}
function checkActive(path, location, getIsActive) {
    return getIsActive ? !!getIsActive(path, location) : path === location.raw;
}
