import React from 'react';
import Controller from '../controller';
import type { Actions } from 'relite';
import type { BaseState } from '..';
export interface ViewManagerProps<S extends object, AS extends Actions<S & BaseState>> {
    controller: Controller<S, AS>;
}
export default class ViewManager<S extends object, AS extends Actions<S & BaseState>> extends React.Component<ViewManagerProps<S, AS>> {
    static ignoreErrors: boolean;
    views: Record<string, any>;
    scrollMap: Record<string, any>;
    constructor(props: ViewManagerProps<S, AS>, context: React.Context<any>);
    addItemIfNeed(key: string): void;
    clearItemIfNeed(): void;
    UNSAFE_componentWillReceiveProps(nextProps: ViewManagerProps<S, AS>): void;
    renderView(path: string): any;
    render(): JSX.Element;
}
