import React from 'react';
export type ExcludeFromObject<T, E> = Pick<T, Exclude<keyof T, keyof E>>;
export interface With<EP extends object> {
    <P extends object>(inputComponent: React.ComponentType<P>): (props: ExcludeFromObject<P, EP>) => React.ReactElement;
}
declare function connect<S extends (props: any) => any>(selector?: S): With<ReturnType<S>>;
export default connect;
