"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var context_1 = __importDefault(require("../context"));
function connect(selector) {
    return function (InputComponent) {
        return function Connector(props) {
            return (react_1.default.createElement(context_1.default.Consumer, null, function (_a) {
                var state = _a.state, ctrl = _a.ctrl;
                var sProps = selector ? selector({ state: state, ctrl: ctrl, props: props }) : {};
                return react_1.default.createElement(InputComponent, __assign({}, props, sProps));
            }));
        };
    };
}
exports.default = connect;
