/**
 * 缓存视图-中间件
 */
import express from 'express';
import type { RequestHandler } from '..';
interface Settings {
    timeout: number;
    max: number;
    headers: Record<string, string>;
    key: (url: string, req: express.Request) => string;
    debug: boolean;
}
export default function cacheView(settings: Settings): RequestHandler;
export {};
