"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var Script_1 = __importDefault(require("../component/Script"));
function Page(props) {
    return (react_1.default.createElement("html", null,
        react_1.default.createElement("head", null,
            react_1.default.createElement("meta", { charSet: "utf-8" }),
            react_1.default.createElement("meta", { name: "viewport", content: "width=device-width, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0, user-scalable=no, minimal-ui" }),
            react_1.default.createElement("meta", { content: "yes", name: "apple-mobile-web-app-capable" }),
            react_1.default.createElement("meta", { name: "apple-mobile-web-app-status-bar-style", content: "black-translucent" }),
            react_1.default.createElement("meta", { content: "black", name: "apple-mobile-web-app-status-bar-style" }),
            react_1.default.createElement("title", null, props.title),
            react_1.default.createElement("meta", { name: "description", content: props.description }),
            react_1.default.createElement("meta", { name: "keywords", content: props.keywords })),
        react_1.default.createElement("body", null,
            react_1.default.createElement("div", { id: "root", dangerouslySetInnerHTML: { __html: props.content } }),
            react_1.default.createElement("div", { id: "modal" }),
            react_1.default.createElement(Script_1.default, null, "\n          (function() {\n              window.__INITIAL_STATE__ = ".concat(JSON.stringify(props.initialState), "\n              window.__APP_SETTINGS__ = ").concat(JSON.stringify(props.appSettings), "\n              window.__PUBLIC_PATH__ = '").concat(props.publicPath, "'\n          })()\n         ")),
            react_1.default.createElement("script", { src: "".concat(props.publicPath, "/").concat(props.assets.vendor) }),
            react_1.default.createElement("script", { src: "".concat(props.publicPath, "/").concat(props.assets.index) }))));
}
exports.default = Page;
