"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function consolePolyfill(window) {
    // Avoid `console` errors in browsers that lack a console.
    var method;
    var noop = function () { };
    var methods = [
        'assert',
        'clear',
        'count',
        'debug',
        'dir',
        'dirxml',
        'error',
        'exception',
        'group',
        'groupCollapsed',
        'groupEnd',
        'info',
        'log',
        'markTimeline',
        'profile',
        'profileEnd',
        'table',
        'time',
        'timeEnd',
        'timeline',
        'timelineEnd',
        'timeStamp',
        'trace',
        'warn',
        'msIsIndependentlyComposed',
    ];
    var length = methods.length;
    var console = (window.console = window.console || {});
    while (length--) {
        method = methods[length];
        // Only stub undefined methods.
        if (!console[method]) {
            console[method] = noop;
        }
    }
}
consolePolyfill(typeof window !== 'undefined' ? window : {});
