"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
process.env.NODE_ENV = process.env.NODE_ENV || 'development';
var yargs_1 = __importDefault(require("yargs"));
var start_1 = __importDefault(require("../start"));
var config_1 = __importDefault(require("../config"));
var config_defaults_1 = __importDefault(require("../config/config.defaults"));
if (process.env.NODE_ENV === 'development') {
    var config = (0, config_1.default)(yargs_1.default.argv);
    require('@babel/register')(__assign(__assign({}, config.babel(config_defaults_1.default)), { extensions: ['.es6', '.es', '.jsx', '.js', '.mjs', '.ts', '.tsx'] }));
}
(0, start_1.default)(yargs_1.default.argv);
